Index: /extensions/SmartAlbums/include/functions.inc.php
===================================================================
--- /extensions/SmartAlbums/include/functions.inc.php	(revision 26441)
+++ /extensions/SmartAlbums/include/functions.inc.php	(revision 26442)
@@ -1,4 +1,4 @@
 <?php
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('SMART_PATH') or die('Hacking attempt!');
 
 /*
@@ -10,13 +10,13 @@
 {
   $query = '
-DELETE FROM '.IMAGE_CATEGORY_TABLE.' 
-  WHERE 
-    category_id = '.$cat_id.' 
+DELETE FROM '.IMAGE_CATEGORY_TABLE.'
+  WHERE
+    category_id = '.$cat_id.'
     AND smart = true
 ;';
   pwg_query($query);
-  
+
   $images = smart_get_pictures($cat_id);
-  
+
   if (count($images) != 0)
   {
@@ -30,11 +30,11 @@
     }
     mass_inserts(
-      IMAGE_CATEGORY_TABLE, 
-      array_keys($datas[0]), 
+      IMAGE_CATEGORY_TABLE,
+      array_keys($datas[0]),
       $datas,
       array('ignore'=>true)
       );
   }
-  
+
   // representant, try to not overwrite if still in images list
   $query = '
@@ -44,11 +44,11 @@
 ;';
   list($rep_id) = pwg_db_fetch_row(pwg_query($query));
-  
-  if ( !in_array($rep_id, $images) )
+
+  if (!in_array($rep_id, $images))
   {
     include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
     set_random_representant(array($cat_id));
   }
-  
+
   $query = '
 UPDATE '.CATEGORY_FILTERS_TABLE.'
@@ -57,5 +57,5 @@
 ;';
   pwg_query($query);
-  
+
   return $images;
 }
@@ -69,17 +69,18 @@
 {
   global $conf;
-  
-  if ( defined('SMART_NOT_UPDATE') OR !$conf['SmartAlbums']['update_on_upload'] ) return;
-  
+
+  if (defined('SMART_NOT_UPDATE'))
+  {
+    return;
+  }
+
   // get categories with smart filters
   $query = '
-SELECT DISTINCT id
-  FROM '.CATEGORIES_TABLE.' AS c
-    INNER JOIN '.CATEGORY_FILTERS_TABLE.' AS cf
-    ON c.id = cf.category_id
+SELECT DISTINCT category_id
+  FROM '.CATEGORY_FILTERS_TABLE.'
 ;';
-  
+
   // regenerate photo list
-  $smart_cats = array_from_query($query, 'id');
+  $smart_cats = query2array($query, null, 'category_id');
   array_map('smart_make_associations', $smart_cats);
 }
@@ -97,16 +98,19 @@
 
   /* get filters */
-  if ($filters === null)
+  if (!isset($filters))
   {
     $query = '
-SELECT * 
-  FROM '.CATEGORY_FILTERS_TABLE.' 
-  WHERE category_id = '.$cat_id.' 
+SELECT *
+  FROM '.CATEGORY_FILTERS_TABLE.'
+  WHERE category_id = '.$cat_id.'
   ORDER BY type ASC, cond ASC
 ;';
     $result = pwg_query($query);
-    
-    if (!pwg_db_num_rows($result)) return array();
-    
+
+    if (!pwg_db_num_rows($result))
+    {
+      return array();
+    }
+
     $filters = array();
     while ($row = pwg_db_fetch_assoc($result))
@@ -123,11 +127,14 @@
     return array();
   }
-  
+
   $mode = 'and';
-  
+
   /* build constrains */
   ## generate 'join', 'where' arrays and 'limit' string to create the SQL query
   ## inspired by PicsEngine 3 by Michael Villar
   $i_tags = 1;
+  $join = array();
+  $where = array();
+
   foreach ($filters as $filter)
   {
@@ -142,4 +149,55 @@
           case 'all':
           {
+            $tags_arr = explode(',', $filter['value']);
+            foreach ($tags_arr as $value)
+            {
+              $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+              $where[] = 'it'.$i_tags.'.tag_id = '.$value;
+              $i_tags++;
+            }
+
+            break;
+          }
+          // search images which tags are in the list
+          case 'one':
+          {
+            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+            $where[] = 'it'.$i_tags.'.tag_id IN ('.$filter['value'].')';
+            $i_tags++;
+
+            break;
+          }
+          // exclude images which tags are in the list
+          case 'none':
+          {
+            $sub_query = '
+      SELECT it'.$i_tags.'.image_id
+        FROM '.IMAGE_TAG_TABLE.' AS it'.$i_tags.'
+        WHERE
+          it'.$i_tags.'.image_id = i.id AND
+          it'.$i_tags.'.tag_id IN ('.$filter['value'].')
+        GROUP BY it'.$i_tags.'.image_id
+      ';
+            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+            $where[] = 'NOT EXISTS ('.$sub_query.')';
+            $i_tags++;
+
+            break;
+          }
+          // exclude images which tags are not in the list and search images which have all tags
+          case 'only':
+          {
+            $sub_query = '
+      SELECT it'.$i_tags.'.image_id
+        FROM '.IMAGE_TAG_TABLE.' AS it'.$i_tags.'
+        WHERE
+          it'.$i_tags.'.image_id = i.id AND
+          it'.$i_tags.'.tag_id NOT IN ('.$filter['value'].')
+        GROUP BY it'.$i_tags.'.image_id
+      ';
+            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
+            $where[] = 'NOT EXISTS ('.$sub_query.')';
+            $i_tags++;
+
             $tags_arr = explode(',', $filter['value']);
             foreach($tags_arr as $value)
@@ -149,63 +207,12 @@
               $i_tags++;
             }
-            
-            break;
-          }
-          // search images which tags are in the list
-          case 'one':
-          {
-            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
-            $where[] = 'it'.$i_tags.'.tag_id IN ('.$filter['value'].')';
-            $i_tags++;
-            
-            break;
-          }
-          // exclude images which tags are in the list
-          case 'none':
-          {
-            $sub_query = '
-      SELECT it'.$i_tags.'.image_id
-        FROM '.IMAGE_TAG_TABLE.' AS it'.$i_tags.'
-        WHERE 
-          it'.$i_tags.'.image_id = i.id AND
-          it'.$i_tags.'.tag_id IN ('.$filter['value'].')
-        GROUP BY it'.$i_tags.'.image_id
-      ';
-            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
-            $where[] = 'NOT EXISTS ('.$sub_query.')';
-            $i_tags++;
-            
-            break;
-          }
-          // exclude images which tags are not in the list and search images which have all tags
-          case 'only':
-          {
-            $sub_query = '
-      SELECT it'.$i_tags.'.image_id
-        FROM '.IMAGE_TAG_TABLE.' AS it'.$i_tags.'
-        WHERE 
-          it'.$i_tags.'.image_id = i.id AND
-          it'.$i_tags.'.tag_id NOT IN ('.$filter['value'].')
-        GROUP BY it'.$i_tags.'.image_id
-      ';
-            $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
-            $where[] = 'NOT EXISTS ('.$sub_query.')';
-            $i_tags++;
-            
-            $tags_arr = explode(',', $filter['value']);
-            foreach($tags_arr as $value)
-            {
-              $join[] = IMAGE_TAG_TABLE.' AS it'.$i_tags.' ON i.id = it'.$i_tags.'.image_id';
-              $where[] = 'it'.$i_tags.'.tag_id = '.$value;
-              $i_tags++;
-            }
-            
-            break;
-          }
-        }
-        
-        break;
-      }
-    
+
+            break;
+          }
+        }
+
+        break;
+      }
+
       // date
       case 'date':
@@ -232,8 +239,8 @@
             break;
         }
-        
-        break;
-      }
-      
+
+        break;
+      }
+
       // name
       case 'name':
@@ -263,8 +270,8 @@
             break;
         }
-        
-        break;
-      }
-      
+
+        break;
+      }
+
       // album
       case 'album':
@@ -279,5 +286,5 @@
             {
               $sub_query = '
-      SELECT image_id 
+      SELECT image_id
         FROM '.IMAGE_CATEGORY_TABLE.'
         WHERE category_id = '.$value.'
@@ -285,5 +292,5 @@
               $where[] = 'i.id IN ('.$sub_query.')';
             }
-            
+
             break;
           }
@@ -297,5 +304,5 @@
       ';
             $where[] = 'i.id IN ('.$sub_query.')';
-            
+
             break;
           }
@@ -309,5 +316,5 @@
       ';
             $where[] = 'i.id NOT IN ('.$sub_query.')';
-            
+
             break;
           }
@@ -321,10 +328,10 @@
       ';
             $where[] = 'i.id NOT IN ('.$sub_query.')';
-            
+
             $albums_arr = explode(',', $filter['value']);
             foreach($albums_arr as $value)
             {
               $sub_query = '
-      SELECT image_id 
+      SELECT image_id
         FROM '.IMAGE_CATEGORY_TABLE.'
         WHERE category_id = '.$value.'
@@ -332,17 +339,17 @@
               $where[] = 'i.id IN ('.$sub_query.')';
             }
-            
-            break;
-          }
-        }
-        
-        break;
-      }
-      
+
+            break;
+          }
+        }
+
+        break;
+      }
+
       // dimensions
       case 'dimensions':
       {
         $filter['value'] = explode(',', $filter['value']);
-        
+
         switch ($filter['cond'])
         {
@@ -358,5 +365,5 @@
         }
       }
-      
+
       // author
       case 'author':
@@ -384,8 +391,8 @@
             break;
         }
-        
-        break;
-      }
-      
+
+        break;
+      }
+
       // hit
       case 'hit':
@@ -400,8 +407,8 @@
             break;
         }
-        
-        break;
-      }
-      
+
+        break;
+      }
+
       // rating_score
       case 'rating_score':
@@ -416,8 +423,8 @@
             break;
         }
-        
-        break;
-      }
-      
+
+        break;
+      }
+
       // level
       case 'level':
@@ -426,5 +433,5 @@
         break;
       }
-      
+
       // limit
       case 'limit':
@@ -433,5 +440,5 @@
         break;
       }
-      
+
       // mode
       case 'mode':
@@ -442,16 +449,16 @@
     }
   }
-  
+
   /* bluid query */
   $MainQuery = '
 SELECT i.id
   FROM '.IMAGES_TABLE.' AS i';
-    
-    if (isset($join))
+
+    if (count($join))
     {
       $MainQuery.= '
     LEFT JOIN '.implode("\n    LEFT JOIN ", $join);
     }
-    if (isset($where))
+    if (count($where))
     {
       $MainQuery.= '
@@ -471,6 +478,6 @@
     file_put_contents(SMART_PATH.'dump_query.sql', $MainQuery);
   }
-  
-  return array_from_query($MainQuery, 'id');
+
+  return query2array($MainQuery, null, 'id');
 }
 
@@ -484,9 +491,9 @@
 {
   global $page, $limit_is_set, $level_is_set;
+
   $error = false;
-  
   if (!isset($limit_is_set)) $limit_is_set = false;
   if (!isset($level_is_set)) $level_is_set = false;
-  
+
   switch ($filter['type'])
   {
@@ -496,6 +503,5 @@
       if ($filter['value'] == null)
       {
-        $error = true;
-        array_push($page['errors'], l10n('No tag selected'));
+        $page['errors'][] = l10n('No tag selected');
       }
       else
@@ -511,6 +517,5 @@
       if (!preg_match('#([0-9]{4})-([0-9]{2})-([0-9]{2})#', $filter['value']))
       {
-        $error = true;
-        array_push($page['errors'], l10n('Date string is malformed'));
+        $page['errors'][] = l10n('Date string is malformed');
       }
       break;
@@ -521,11 +526,9 @@
       if (empty($filter['value']))
       {
-        $error = true;
-        array_push($page['errors'], l10n('Name is empty'));
-      }
-      else if ( $filter['cond']=='regex' and @preg_match('/'.$filter['value'].'/', null)===false )
-      {
-        $error = true;
-        array_push($page['errors'], l10n('Regex is malformed'));
+        $page['errors'][] = l10n('Name is empty');
+      }
+      else if ($filter['cond']=='regex' and @preg_match('/'.$filter['value'].'/', null)===false)
+      {
+        $page['errors'][] = l10n('Regex is malformed');
       }
       break;
@@ -536,6 +539,5 @@
       if (@$filter['value'] == null)
       {
-        $error = true;
-        array_push($page['errors'], l10n('No album selected'));
+        $page['errors'][] = l10n('No album selected');
       }
       else
@@ -548,5 +550,5 @@
     case 'dimensions':
     {
-      if ( empty($filter['value']['min']) or empty($filter['value']['max']) )
+      if (empty($filter['value']['min']) or empty($filter['value']['max']))
       {
         $error = true;
@@ -563,11 +565,9 @@
       if (empty($filter['value']))
       {
-        $error = true;
-        array_push($page['errors'], l10n('Author is empty'));
-      }
-      else if ( $filter['cond']=='regex' and @preg_match('/'.$filter['value'].'/', null)===false )
-      {
-        $error = true;
-        array_push($page['errors'], l10n('Regex is malformed'));
+        $page['errors'][] = l10n('Author is empty');
+      }
+      else if ($filter['cond']=='regex' and @preg_match('/'.$filter['value'].'/', null)===false)
+      {
+        $page['errors'][] = l10n('Regex is malformed');
       }
       else
@@ -580,8 +580,7 @@
     case 'hit':
     {
-      if (!preg_match('#([0-9]{1,})#', $filter['value']))
-      {
-        $error = true;
-        array_push($page['errors'], l10n('Hits must be an integer'));
+      if (!preg_match('#([0-9]+)#', $filter['value']))
+      {
+        $page['errors'][] = l10n('Hits must be an integer');
       }
       break;
@@ -590,8 +589,7 @@
     case 'rating_score':
     {
-      if (!preg_match('#([0-9]{1,})#', $filter['value']))
-      {
-        $error = true;
-        array_push($page['errors'], l10n('Rating score must be an integer'));
+      if (!preg_match('#([0-9]+)#', $filter['value']))
+      {
+        $page['errors'][] = l10n('Rating score must be an integer');
       }
       break;
@@ -602,6 +600,5 @@
       if ($level_is_set == true) // only one level is allowed, first is saved
       {
-        $error = true;
-        array_push($page['errors'], l10n('You can\'t use more than one level filter'));
+        $page['errors'][] = l10n('You can\'t use more than one level filter');
       }
       else
@@ -617,15 +614,13 @@
       if ($limit_is_set == true) // only one limit is allowed, first is saved
       {
-        $error = true;
-        array_push($page['errors'], l10n('You can\'t use more than one limit filter'));
-      }
-      else if (!preg_match('#([0-9]{1,})#', $filter['value']))
-      {
-        $error = true;
-        array_push($page['errors'], l10n('Limit must be an integer'));
-      }
-      else 
-      {
-        $filter['cond'] = 'level';
+        $page['errors'][] = l10n('You can\'t use more than one limit filter');
+      }
+      else if (!preg_match('#([0-9]+)#', $filter['value']))
+      {
+        $page['errors'][] = l10n('Limit must be an integer');
+      }
+      else
+      {
+        $filter['cond'] = 'limit';
         $limit_is_set = true;
       }
@@ -638,5 +633,5 @@
       break;
     }
-    
+
     default:
     {
@@ -645,7 +640,7 @@
     }
   }
-  
-  
-  if ($error == false)
+
+
+  if (!$error && empty($page['errors']))
   {
     return $filter;
@@ -656,44 +651,2 @@
   }
 }
-
-
-/**
- * clean table when categories are deleted
- */
-function smart_delete_categories($ids)
-{
-  $query = '
-DELETE FROM '.CATEGORY_FILTERS_TABLE.'
-  WHERE category_id IN('.implode(',', $ids).')
-;';
-  pwg_query($query);
-}
-
-/**
- * update images list periodically
- */
-function smart_periodic_update()
-{
-  global $conf;
-  
-  // we only search for old albums every hour, nevermind which user is connected
-  if ($conf['SmartAlbums']['last_update'] > time() - 3600) return;
-  
-  $conf['SmartAlbums']['last_update'] = time();
-  conf_update_param('SmartAlbums', serialize($conf['SmartAlbums']));
-  
-  // get categories with smart filters
-  $query = '
-SELECT DISTINCT id
-  FROM '.CATEGORIES_TABLE.' AS c
-    INNER JOIN '.CATEGORY_FILTERS_TABLE.' AS cf
-    ON c.id = cf.category_id
-  WHERE updated < DATE_SUB(NOW(), INTERVAL '.$conf['SmartAlbums']['update_timeout'].' DAY)
-;';
-  
-  // regenerate photo list
-  $smart_cats = array_from_query($query, 'id');
-  array_map('smart_make_associations', $smart_cats);
-}
-
-?>
Index: /extensions/SmartAlbums/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/SmartAlbums/language/en_UK/plugin.lang.php	(revision 26441)
+++ /extensions/SmartAlbums/language/en_UK/plugin.lang.php	(revision 26442)
@@ -2,6 +2,4 @@
 
 $lang['No filter selected'] = 'No filter selected';
-$lang['%d photo'] = '%d photo';
-$lang['%d photos'] = '%d photos';
 $lang['All these tags'] = 'All these tags';
 $lang['One of these tags'] = 'One of these tags';
@@ -63,4 +61,7 @@
 $lang['SmartAlbums are considered private for everyone, and a user can see it\'s content only if available in another album he has access to.'] = 'SmartAlbums are considered private for everyone, and a user can see it\'s content only if available in another album he has access to.';
 $lang['Update albums every %s days'] = 'Update albums every %s days';
+$lang['Invalid number of days'] = 'Invalid number of days';
+$lang['Mode'] = 'Mode';
+$lang['Select albums...'] = 'Select albums...';
 
 ?>
Index: /extensions/SmartAlbums/language/fr_FR/plugin.lang.php
===================================================================
--- /extensions/SmartAlbums/language/fr_FR/plugin.lang.php	(revision 26441)
+++ /extensions/SmartAlbums/language/fr_FR/plugin.lang.php	(revision 26442)
@@ -2,6 +2,4 @@
 
 $lang['No filter selected'] = 'Aucun filtre sélectionné';
-$lang['%d photo'] = '%d photo';
-$lang['%d photos'] = '%d photos';
 $lang['All these tags'] = 'Tous les tags';
 $lang['One of these tags'] = 'Un des tags';
@@ -63,4 +61,7 @@
 $lang['SmartAlbums are considered private for everyone, and a user can see it\'s content only if available in another album he has access to.'] = 'Les SmartAlbums sont considérés comme privés pour tout le monde, et un utilisateur ne peut voir leur contenu que si disponible dans un autre album auquel il a accès.';
 $lang['Update albums every %s days'] = 'Mettre à jour les albums tous les %s jours';
+$lang['Invalid number of days'] = 'Nombre de jour invalide';
+$lang['Mode'] = 'Mode';
+$lang['Select albums...'] = 'Albums...';
 
 ?>
Index: /extensions/SmartAlbums/main.inc.php
===================================================================
--- /extensions/SmartAlbums/main.inc.php	(revision 26441)
+++ /extensions/SmartAlbums/main.inc.php	(revision 26442)
@@ -4,32 +4,34 @@
 Version: auto
 Description: Easily create dynamic albums with tags, date and other criteria
-Plugin URI: http://piwigo.org/ext/extension_view.php?eid=544
+Plugin URI: auto
 Author: Mistic
 Author URI: http://www.strangeplanet.fr
 */
 
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');
+
 global $prefixeTable;
 
-define('SMART_PATH',     PHPWG_PLUGINS_PATH . 'SmartAlbums/');
+define('SMART_ID',      'SmartAlbums');
+define('SMART_PATH',    PHPWG_PLUGINS_PATH . SMART_ID . '/');
 define('CATEGORY_FILTERS_TABLE', $prefixeTable . 'category_filters');
-define('SMART_ADMIN',    get_root_url() . 'admin.php?page=plugin-SmartAlbums');
-define('SMART_VERSION',  'auto');
-//define('SMART_DEBUG',    true);
+define('SMART_ADMIN',   get_root_url() . 'admin.php?page=plugin-' . SMART_ID);
+define('SMART_VERSION', 'auto');
+// define('SMART_DEBUG',   true);
 
 
 add_event_handler('init', 'smart_init');
 add_event_handler('init', 'smart_periodic_update');
-add_event_handler('invalidate_user_cache', 'smart_make_all_associations');
+add_event_handler('delete_categories', 'smart_delete_categories');
 
 if (defined('IN_ADMIN'))
 {
-  include_once(SMART_PATH.'include/cat_list.php');
+  include_once(SMART_PATH.'include/events_admin.inc.php');
   add_event_handler('loc_begin_cat_list', 'smart_cat_list');
-  add_event_handler('tabsheet_before_select','smart_tab', EVENT_HANDLER_PRIORITY_NEUTRAL, 2); 
+  add_event_handler('tabsheet_before_select','smart_tab', EVENT_HANDLER_PRIORITY_NEUTRAL, 2);
   add_event_handler('get_admin_plugin_menu_links', 'smart_admin_menu');
-  add_event_handler('delete_categories', 'smart_delete_categories');
 }
 
+include_once(SMART_PATH.'include/events.inc.php');
 include_once(SMART_PATH.'include/functions.inc.php');
 
@@ -40,32 +42,10 @@
 function smart_init()
 {
-  global $conf, $pwg_loaded_plugins;
-  
-  if (
-    SMART_VERSION == 'auto' or
-    $pwg_loaded_plugins['SmartAlbums']['version'] == 'auto' or
-    version_compare($pwg_loaded_plugins['SmartAlbums']['version'], SMART_VERSION, '<')
-  )
-  {
-    include_once(SMART_PATH . 'include/install.inc.php');
-    smart_albums_install();
-    
-    if ( $pwg_loaded_plugins['SmartAlbums']['version'] != 'auto' and SMART_VERSION != 'auto' )
-    {
-      $query = '
-UPDATE '. PLUGINS_TABLE .'
-SET version = "'. SMART_VERSION .'"
-WHERE id = "SmartAlbums"';
-      pwg_query($query);
-      
-      $pwg_loaded_plugins['SmartAlbums']['version'] = SMART_VERSION;
-      
-      if (defined('IN_ADMIN'))
-      {
-        $_SESSION['page_infos'][] = 'Smart Albums updated to version '. SMART_VERSION;
-      }
-    }
-  }
-  
+  global $conf;
+
+  include_once(SMART_PATH . 'maintain.inc.php');
+  $maintain = new SmartAlbums_maintain(SMART_ID);
+  $maintain->autoUpdate(SMART_VERSION, 'install');
+
   if (defined('IN_ADMIN'))
   {
@@ -73,44 +53,13 @@
   }
   $conf['SmartAlbums'] = unserialize($conf['SmartAlbums']);
-  
-  if ( script_basename() == 'index' and $conf['SmartAlbums']['smart_is_forbidden'] )
+
+  if (script_basename() == 'index' and $conf['SmartAlbums']['smart_is_forbidden'])
   {
     add_event_handler('loc_end_section_init', 'smart_init_page_items');
-    include_once(SMART_PATH.'include/page_items.php');
+  }
+
+  if ($conf['SmartAlbums']['update_on_upload'])
+  {
+    add_event_handler('invalidate_user_cache', 'smart_make_all_associations');
   }
 }
-
-/**
- * new tab on album properties page
- */
-function smart_tab($sheets, $id)
-{
-  if ($id != 'album') return $sheets;
-  
-  global $category;
-  
-  if ($category['dir'] == null)
-  {
-    $sheets['smartalbum'] = array(
-      'caption' => 'SmartAlbum',
-      'url' => SMART_ADMIN.'-album&amp;cat_id='.$_GET['cat_id'],
-      );
-  }
-  
-  return $sheets;
-}
-
-
-/**
- * admin plugins menu link
- */
-function smart_admin_menu($menu) 
-{
-  array_push($menu, array(
-      'NAME' => 'SmartAlbums',
-      'URL' => SMART_ADMIN,
-    ));
-  return $menu;
-}
-
-?>
Index: /extensions/SmartAlbums/maintain.inc.php
===================================================================
--- /extensions/SmartAlbums/maintain.inc.php	(revision 26441)
+++ /extensions/SmartAlbums/maintain.inc.php	(revision 26442)
@@ -1,29 +1,140 @@
 <?php
-if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');
 
-include_once(PHPWG_PLUGINS_PATH . 'SmartAlbums/include/install.inc.php');
+class SmartAlbums_maintain extends PluginMaintain
+{
+  private $installed = false;
 
-function plugin_install() 
-{
-  smart_albums_install();
-  define('smart_albums_installed', true);
-}
+  private $default_conf = array(
+    'update_on_upload' => false,
+    'update_on_date' => true,
+    'update_timeout' => 3,
+    'show_list_messages' => true,
+    'smart_is_forbidden' => false,
+    'last_update' => 0,
+    );
 
-function plugin_activate()
-{ 
-  if (!defined('smart_albums_installed'))
+  private $table;
+
+  function __construct($plugin_id)
   {
-    smart_albums_install();
+    global $prefixeTable;
+
+    parent::__construct($plugin_id);
+
+    $this->table = $prefixeTable . 'category_filters';
+  }
+
+  function install($plugin_version, &$errors=array())
+  {
+    global $conf, $prefixeTable;
+
+    if (empty($conf['SmartAlbums']))
+    {
+      $conf['SmartAlbums'] = serialize($this->default_conf);
+      conf_update_param('SmartAlbums', $conf['SmartAlbums']);
+    }
+    else
+    {
+      $new_conf = is_string($conf['SmartAlbums']) ? unserialize($conf['SmartAlbums']) : $conf['SmartAlbums'];
+
+      // new param in 2.0.2
+      if (!isset($new_conf['smart_is_forbidden']))
+      {
+        $new_conf['smart_is_forbidden'] = true;
+      }
+
+      // new params in 2.1.0
+      if (!isset($new_conf['update_on_date']))
+      {
+        $new_conf['update_on_date'] = true;
+        $new_conf['update_timeout'] = 3;
+        $new_conf['last_update'] = 0;
+      }
+
+      $conf['SmartAlbums'] = serialize($new_conf);
+      conf_update_param('SmartAlbums', $conf['SmartAlbums']);
+    }
+
+    // new table
+    pwg_query(
+'CREATE TABLE IF NOT EXISTS `' . $this->table . '` (
+  `category_id` smallint(5) unsigned NOT NULL,
+  `type` varchar(16) NOT NULL,
+  `cond` varchar(16) NULL,
+  `value` text NULL,
+  `updated` DATETIME NOT NULL DEFAULT "1970-01-01 00:00:00"
+) ENGINE=MyISAM DEFAULT CHARSET=utf8
+;');
+
+    // new column on image category table
+    $result = pwg_query('SHOW COLUMNS FROM `' . IMAGE_CATEGORY_TABLE . '` LIKE "smart";');
+    if (!pwg_db_num_rows($result))
+    {
+      pwg_query('ALTER TABLE `' . IMAGE_CATEGORY_TABLE . '` ADD `smart` ENUM(\'true\', \'false\') NOT NULL DEFAULT \'false\';');
+    }
+
+    // new column on category filters table (2.1.1)
+    $result = pwg_query('SHOW COLUMNS FROM `' . $this->table . '` LIKE "updated";');
+    if (!pwg_db_num_rows($result))
+    {
+      pwg_query('ALTER TABLE `' . $this->table . '` ADD `updated` DATETIME NOT NULL DEFAULT "1970-01-01 00:00:00"');
+    }
+
+    // remove column on category table, moved to category filters table (2.1.1)
+    $result = pwg_query('SHOW COLUMNS FROM `' . CATEGORIES_TABLE . '` LIKE "smart_update";');
+    if (pwg_db_num_rows($result))
+    {
+      pwg_query('UPDATE `' . $this->table . '` AS f SET updated = ( SELECT smart_update FROM `' . CATEGORIES_TABLE . '` AS c WHERE c.id = f.category_id );');
+      pwg_query('ALTER TABLE `' . CATEGORIES_TABLE . '` DROP `smart_update`;');
+    }
+
+    // date filters renamed in 2.0
+    $query = '
+SELECT category_id
+  FROM `' . $this->table . '`
+  WHERE
+    type = "date" AND
+    cond IN ("the","before","after","the_crea","before_crea","after_crea")
+;';
+
+    if (pwg_db_num_rows(pwg_query($query)))
+    {
+      $name_changes = array(
+        'the' => 'the_post',
+        'before' => 'before_post',
+        'after' => 'after_post',
+        'the_crea' => 'the_taken',
+        'before_crea' => 'before_taken',
+        'after_crea' => 'after_taken',
+        );
+      foreach ($name_changes as $old => $new)
+      {
+        pwg_query('UPDATE `' . $this->table . '` SET cond = "' . $new . '" WHERE type = "date" AND cond = "' . $old . '";');
+      }
+    }
+
+    $this->installed = true;
+  }
+
+  function activate($plugin_version, &$errors=array())
+  {
+    if (!$this->installed)
+    {
+      $this->install($plugin_version, $errors);
+    }
+  }
+
+  function deactivate()
+  {
+  }
+
+  function uninstall()
+  {
+    conf_delete_param('SmartAlbums');
+
+    pwg_query('DROP TABLE `' . $this->table . '`;');
+
+    pwg_query('ALTER TABLE `' . IMAGE_CATEGORY_TABLE . '` DROP `smart`;');
   }
 }
-
-function plugin_uninstall() 
-{
-  global $prefixeTable;
-  
-  pwg_query('DROP TABLE `' . $prefixeTable . 'category_filters`;');
-  pwg_query('ALTER TABLE `' . IMAGE_CATEGORY_TABLE . '` DROP `smart`;');
-  pwg_query('DELETE FROM `' . CONFIG_TABLE . '` WHERE param = \'SmartAlbums\' LIMIT 1;');
-}
-
-?>
